#<profile4xi profile = "11" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "test_all_methods4xi.py">
#<abstract4xi abstract = "tests all_methods4xi"/>
#<verify4xi verification = "10" target = "all_methods4xi.py"/>
#<contextualize4xi context = "lock4xi.py; manager4xi.py; pipe4xi.py; process4xi.py; queue4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------


# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'main',
            'test_all_methods4xi',
            'set_trace4xi',                        
            'print_trace4xi'            
            'sense']
#"
#/>

#/>
# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi  

#" 
#/>
# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from all_methods4xi import all_methods4xi

from lock4xi import Lock4Xi
from manager4xi import Manager4Xi

from pipe4xi import Pipe4Xi
from print4xi import Print4Xi
from print4xi import print4xi
from print4xi import set_print_permission4xi
from process4xi import Process4Xi

from queue4xi import Queue4Xi

from print4xi import Print4Xi
from pickle4xi import pickle4xi
from pickle2a4xi import Pickle2a4Xi
from pickle2b4xi import Pickle2b4Xi
from pickle2c4xi import Pickle2c4Xi
from pickle2d4xi import Pickle2d4Xi
from pickle2e4xi import Pickle2e4Xi
from pickle2f4xi import Pickle2f4Xi
from pickle2g4xi import Pickle2g4Xi
from pickle2h4xi import Pickle2h4Xi
from pickle2i4xi import Pickle2i4Xi
from pickle2j4xi import Pickle2j4Xi
from pickle2k4xi import Pickle2k4Xi
from pickle2l4xi import Pickle2l4Xi
from pickle2m4xi import Pickle2m4Xi
from pickle2n4xi import Pickle2n4Xi
from pickle2o4xi import Pickle2o4Xi
from pickle2p4xi import Pickle2p4Xi
from pickle2q4xi import Pickle2q4Xi
from pickle2r4xi import Pickle2r4Xi
from pickle2s4xi import Pickle2s4Xi
from pickle2t4xi import Pickle2t4Xi
from pickle2u4xi import Pickle2u4Xi
from pickle2v4xi import Pickle2v4Xi
from pickle2w4xi import Pickle2w4Xi
from pickle2x4xi import Pickle2x4Xi
from pickle2y4xi import Pickle2y4Xi
from pickle2z4xi import Pickle2z4Xi
from pickle2_4xi import Pickle2_4Xi      

from time4xi import time4xi

from xml_trace_sense4xi import xml_trace_sense4xi
from xml_trace_reason4xi import xml_trace_reason4xi
from xml_trace_ace4xi import xml_trace_ace4xi 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global t2xi 
global trace_object_count
global PickleKB4Xi

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
PickleKB4Xi = {
       'a': Pickle2a4Xi,
       'b': Pickle2b4Xi,
       'c': Pickle2c4Xi,
       'd': Pickle2d4Xi,
       'e': Pickle2e4Xi,
       'f': Pickle2f4Xi,
       'g': Pickle2g4Xi,
       'h': Pickle2h4Xi,
       'i': Pickle2i4Xi,
       'j': Pickle2j4Xi,
       'k': Pickle2k4Xi,
       'l': Pickle2l4Xi,
       'm': Pickle2m4Xi,
       'n': Pickle2n4Xi,
       'o': Pickle2o4Xi,
       'p': Pickle2p4Xi,
       'q': Pickle2q4Xi,
       'r': Pickle2r4Xi,
       's': Pickle2s4Xi,
       't': Pickle2t4Xi,
       'u': Pickle2u4Xi,
       'v': Pickle2v4Xi,
       'w': Pickle2w4Xi,
       'x': Pickle2x4Xi,
       'y': Pickle2y4Xi,
       'z': Pickle2z4Xi,
       '_': Pickle2_4Xi} 
#"
#"/>


# ----------------------------------------------------------------------------------------------------------
#<function4xi function = "set2trace4xi" usage = "setting trace using definitions in pickle4xi functions !
#">                      
# ----------------------------------------------------------------------------------------------------------    
def set2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    # print("(Step 0A/33) OF SET2TRACE4XI - STARTING SETTING TRACE BASED ON TRACE SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    # print("(Step 0B/33) OF SET2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>    
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('=' *33)
        # print("STARTING LETTER : ", key2pickledb)
        # print('=' *33)
   
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("STARTING DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
        # 
        keys2dictionary = sorted(dictionary2pickle.keys())
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
            # -------------------------------------------------------------------------------------     
            # print('~' *33)        
            object2pickle = key2dictionary        
            # print("STARTING OBJECT: ", object2pickle)
            # print('~' *33)         
            # pickle4xi(object2pickle)
            # print('~' *33)                  
            # print("PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            # ---------------------------------------------------------------------------------    
            # Mark those with NACK4XI to be traced !
            # ---------------------------------------------------------------------------------     
            if dictionary2pickle[key2dictionary] == 'NACK4XI':
                set_param2xi = True     
                key_param = object2pickle     
                t2xi.set_print_permission(key_param, set_param2xi)
                # print("(Step 2A/33) OF SET2TRACE4XI - MARKED TO BE TRACED OBJECT: ", object2pickle)                                
                # 
            else:
                pass  
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('~' *33)        
        # print("COMPLETED  DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print('=' *33)
    # print("COMPLETED LETTER : ", key2pickledb)
    # print('=' *33)
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    print('=' *33)
    print("(Step 33/33) OF SET2TRACE4XI - COMPLETED SETTING TRACE BASED ON NACK4XI/ACK4XI SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print('=' *33)
#</function4xi> 

       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "deny2trace4xi" usage = "
#   deny trace using pickle4xi functions !
#">                      
# -------------------------------------------------------------------------------------------------    
def deny2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    print("(Step 01A/33) of DENY2TRACE4XI: STARTING DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print("(Step 01B/33) OF DENY2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02A/33) OF DENY2TRACE4XI - STARTING LETTER : ", key2pickledb)
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("(Step 02B/33) OF DENY2TRACE4XI - STARTING DICTIONARY: ", dictionary2pickle)
        keys2dictionary = sorted(dictionary2pickle.keys())
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
   
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
   
            object2pickle = key2dictionary        
            # print("(Step 02C/33) OF DENY2TRACE4XI - STARTING OBJECT: ", object2pickle)
            # pickle4xi(object2pickle)        
            # print("STEP: PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            
            # ---------------------------------------------------------------------------------    
            # ACK4XI = tested .i.e. NOT to be traced! 
            # ---------------------------------------------------------------------------------     
            set_param2xi = 'ACK4XI'     
            key_param = object2pickle     
            t2xi.set_print_permission(key_param, set_param2xi)
            # print("(Step 02D/33) OF DENY2TRACE4XI - MARKED TESTED AND NOT to be traced: ", object2pickle)
            
            dictionary2pickle[key2dictionary] = 'ACK4XI' 
                    
        
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
            # print('~' *33)              
            # print("(Step 02Z/33) OF DENY2TRACE4XI *** FAILED - ERROR IN PICKLING OBJECT - NOT TO BE TRACED: ", object2pickle)
            # print('~' *33) 
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02E/33) OF DENY2TRACE4XI - COMPLETED  DICTIONARY: ", dictionary2pickle)
        # 
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print("(Step 02F/33) OF DENY2TRACE4XI - COMPLETED LETTER : ", key2pickledb)
    # _, a ... z            
    print("(Step 033/33) OF SET2TRACE4XI - COMPLETED DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "tailor2trace4xi" usage = "
#   tailors trace 
#">                      
# -------------------------------------------------------------------------------------------------    
def tailor2trace4xi():
    global trace_object_count
    global PickleKB4Xi 
    global t2xi
 
    print("(Step 001A/33) OF TAILOR2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080> 
                         
    # ---------------------------------------------------------------------------------------------
    # Settings to tailor trace
    # ---------------------------------------------------------------------------------------------
    #<set4xi setting = "
    KB4Tailoring = {
        'all_methods4xi': 'NACK4TRACE'
        }                             
                
    default3trace = 'NACK4TRACE' # we do NOT want trace if object is not found! 
    #"/>
    
    # ---------------------------------------------------------------------------------------------
    # PROCESS KB4Tailoring
    # ---------------------------------------------------------------------------------------------
    keys2tailor = sorted(KB4Tailoring.keys())
    for key2tailor in keys2tailor:
        # ---------------------------------------------------------------------------------    
        # NACK4XI = NOT TESTED .I.E. TO BE TRACED! 
        # ---------------------------------------------------------------------------------     
        set_param2xi = 'NACK4XI'     
        key_param = key2tailor    
        t2xi.set_print_permission(key_param, set_param2xi)
        print("(Step 002A/33) OF TAILOR_TRACE4XI - MARKED TO BE TESTED: ", key2tailor)
        # 
        
    # -----------------------------------------------------------------------------------------    
    # EOF KEYS
    # -----------------------------------------------------------------------------------------     
    print("(Step 0033/33) OF TAILOR_TRACE4XI - COMPLETED  TAILORING: ", time4xi())
    #

    
#</function4xi>       


# -------------------------------------------------------------------------------------------------
#<function4xi function = "sense" usage = "
#   sense function for multiprocessing test
#"> 
#<state4xi status = "ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def sense(target_param, queue_param, pipe_param,lock_param,dict_param,list_param):
    target_xi2 = target_param
    queue_xi2 = queue_param
    pipe_publisher_channel_xi2 = pipe_param
    lock_xi2 = lock_param
    dict_xi2 = dict_param
    list_xi2 = list_param
    
    
    print("SENSE: ", target_xi2)
    # ---------------------------------------------------------------------------------------------
    # put a message to the queue
    # ---------------------------------------------------------------------------------------------
    
    
    queue_xi2.put(['DragonXi2_00', target_xi2, 'sensing!']) # puts to its queue
    
    # ---------------------------------------------------------------------------------------------
    # reserve the pipe using the lock, send messages and release the pipe
    # ---------------------------------------------------------------------------------------------     
    lock_xi2.acquire()

    # ---------------------------------------------------------------------------------------------
    # send 15 messages to pipe
    # ---------------------------------------------------------------------------------------------
            
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_01', 'BIO ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_02', 'CO2 ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_03', 'Coal ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_04', 'Diesel ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_05', 'Electricity ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_06', 'Fusion ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_07', 'Gas ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_08', 'Geo ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_09', 'Hydrogen ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_10', 'Lithium ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_11', 'Nuclear Power ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_12', 'Ocean ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_13', 'Oil ',target_xi2]) 
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_14', 'Solar ',target_xi2])
    pipe_publisher_channel_xi2.send(['DragonXi2_Sensing_15', 'Wind ',target_xi2])

    # ---------------------------------------------------------------------------------------------
    # 15 elements dictionary
    # ---------------------------------------------------------------------------------------------
        
    dict_xi2[1] = "BIO"
    dict_xi2[2] = "CO2"
    dict_xi2[3] = "Coal"
    dict_xi2[4] = "Diesel"
    dict_xi2[5] = "Electricity"
    dict_xi2[6] = "Fusion"
    dict_xi2[7] = "Gas"
    dict_xi2[8] = "Geo"
    dict_xi2[9] = "Hydrogen"
    dict_xi2[10] = "Lithium"
    dict_xi2[11] = "Nuclear Power"
    dict_xi2[12] = "Ocean"
    dict_xi2[13] = "Oil"
    dict_xi2[14] = "Solar"
    dict_xi2[15] = "Wind"
    

    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    
    lock_xi2.release() 
    
          
#</function4xi>

       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "print_trace4xi" usage = "
#   creates XML files
#">                       
# -------------------------------------------------------------------------------------------------    
def print_trace4xi(p2xi):
  

    # -------------------------------------------------------------------------------------------------
    # SENSE                        
    # -------------------------------------------------------------------------------------------------  
   
    context2sense = {
     'file_path4xi': '..\\..\\xml\\sense-all-methods4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi2.com/sense/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.yourdragonxi.org/web/lib/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Sensing of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Classes, methods and messages with context.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="Dragon4Xi#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Sensing All Methods of Classes in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="sensed#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">Classes, Methods and Messages in All Methods.</rdfs:comment>\n'}
      
    xml_trace_sense4xi(p2xi, context2sense)

    # -------------------------------------------------------------------------------------------------
    # REASON                         
    # -------------------------------------------------------------------------------------------------  
        
    context2reason = {
     'file_path4xi': '..\\..\\xml\\reason-all-methods4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Reasoning of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Operations</rdfs:comment>\n',
     'operation_comment4xi': '      <rdfs:comment xml:lang="en">Operations for All Methods in Multiprocessing.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="reasoned#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Operations All Methods in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="reason#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n'}
       
    xml_trace_reason4xi(p2xi, context2reason)

    # -------------------------------------------------------------------------------------------------
    # ACE                         
    # -------------------------------------------------------------------------------------------------  
       
    context2ace = {
     'file_path4xi': '..\\..\\xml\\ace-all-methods4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Acing of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for All Methods in Multiprocessing.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="ACE4Xi#0000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for All Methods in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="ace#0000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">000000</rdfs:comment>\n'}   
    
    xml_trace_ace4xi(p2xi, context2ace)


    # -------------------------------------------------------------------------------------------------
    # end of print_trace4xi                        
    # -------------------------------------------------------------------------------------------------  
#</function4xi>
      

 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "test-all-methods4xi" usage = "
#   tests all methods
#"> 
#<state4xi status = "NACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def test_all_methods4xi():
    global t2xi
    global trace_object_count    
        
    # --------------------------------------------------------------------------------------------- 
    # INITIALIZE TRACE
    # ---------------------------------------------------------------------------------------------        
    t2xi = Print4Xi()
    print("(Step 1/33) OF TEST_XXXXXXXX4Xi - SET T2XI TO: ", t2xi)
    # 
    set2trace4xi()                                                                                               # trace all classes and functions in the system
    deny2trace4xi()                                                                                              # deny trace for all classes and functions in the system
    tailor2trace4xi()                                                                                            # tailor trace for this test   
    
    try:

        # -----------------------------------------------------------------------------------------    
        # Step (01/33 OF TEST_ALL_METHODS4XI) - Queue4Xi - OK
        # -----------------------------------------------------------------------------------------     
        print("STEP(01A/33 OF TEST_ALL_METHODS4XI): TRYING QUEUE2XI METHODS")
        try:
            queue2xi = Queue4Xi()
            print("STEP(01B/33 OF TEST_ALL_METHODS4XI): QUEUE2XI METHODS: ", all_methods4xi(queue2xi))
            # (01/33 OF TEST_ALL_METHODS4XI): queue2xi methods:  ['__class__', '__delattr__', '__eq__', '__format__', '__ge__', '__getattribute__', '__getstate__', '__gt__', '__hash__', '__init__', '__le__', '__lt__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__setstate__', '__sizeof__', '__str__', '__subclasshook__', '_after_fork', '_feed', '_finalize_close', '_finalize_join', '_poll', '_recv', '_send', '_start_thread', 'ace', 'cancel_join_thread', 'close', 'empty', 'full', 'get', 'get_nowait', 'join_thread', 'put', 'put_nowait', 'qsize', 'reason', 'sense']
        except:
            print("STEP(01Z/33 OF TEST_ALL_METHODS4XI): *** FAILED *** ")

        # -----------------------------------------------------------------------------------------    
        # Step (02/33 OF TEST_ALL_METHODS4XI) - Pipe4Xi - OK
        # -----------------------------------------------------------------------------------------     
        print("STEP(02A/33 OF TEST_ALL_METHODS4XI): TRYING PIPE4XI METHODS")                   
        try:
            pipe2xi_consumer_channel, pipe2xi_publisher_channel = Pipe4Xi()
            print("STEP(02B/33 OF TEST_ALL_METHODS4XI): pipe2xi_consumer_channel methods: ", all_methods4xi(pipe2xi_consumer_channel))
            #  (02/33 OF TEST_ALL_METHODS4XI): pipe2xi_consumer_channel methods:  ['__class__', '__delattr__', '__eq__', '__format__', '__ge__', '__getattribute__', '__gt__', '__hash__', '__init__', '__le__', '__lt__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', 'close', 'fileno', 'poll', 'recv', 'recv_bytes', 'recv_bytes_into', 'send', 'send_bytes']
        except:
            print("STEP(02Z/33 OF TEST_ALL_METHODS4XI): *** FAILED *** ")

        # -----------------------------------------------------------------------------------------    
        # Step (03/33 OF TEST_ALL_METHODS4XI) - Pipe4Xi - OK
        # -----------------------------------------------------------------------------------------     
        print("STEP(03A/33 OF TEST_ALL_METHODS4XI): TRYING PIPE2XI_PUBLISHER_CHANNEL METHODS")                            
        try:
            print("STEP(03B/33 OF TEST_ALL_METHODS4XI): PIPE2XI_PUBLISHER_CHANNEL METHODS: ", all_methods4xi(pipe2xi_publisher_channel))    
            # (03/33 OF TEST_ALL_METHODS4XI): pipe2xi_publisher_channel methods:  ['__class__', '__delattr__', '__eq__', '__format__', '__ge__', '__getattribute__', '__gt__', '__hash__', '__init__', '__le__', '__lt__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', 'close', 'fileno', 'poll', 'recv', 'recv_bytes', 'recv_bytes_into', 'send', 'send_bytes']
        except:
            print("STEP(03Z/33 OF TEST_ALL_METHODS4XI): *** FAILED *** ")
                

        # -----------------------------------------------------------------------------------------    
        # Step (04/33 OF TEST_ALL_METHODS4XI) - Lock4Xi - OK
        # -----------------------------------------------------------------------------------------     
        print("STEP(04A/33 OF TEST_ALL_METHODS4XI): TRYING LOCK_XI2 METHODS METHODS")                    
        try:
            lock_xi2 = Lock4Xi()
            print("STEP(04B/33 OF TEST_ALL_METHODS4XI): LOCK_XI2 METHODS: ", all_methods4xi(lock_xi2))
            # (04/33 OF TEST_ALL_METHODS4XI): lock_xi2 methods:  ['__class__', '__delattr__', '__enter__', '__eq__', '__exit__', '__format__', '__ge__', '__getattribute__', '__getstate__', '__gt__', '__hash__', '__init__', '__le__', '__lt__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__setstate__', '__sizeof__', '__str__', '__subclasshook__', '_make_methods', 'ace', 'acquire', 'reason', 'release', 'sense']
        except:
            print("STEP(04Z/33 OF TEST_ALL_METHODS4XI): *** FAILED *** ")
                

        # -----------------------------------------------------------------------------------------    
        # Step (05/33 OF TEST_ALL_METHODS4XI) - Manager4Xi- OK
        # -----------------------------------------------------------------------------------------     
        print("STEP(05A/33 OF TEST_ALL_METHODS4XI): TRYING TO CREATE MANAGER2XI")                       
        try:
            manager2xi = Manager4Xi()
            print("STEP(05B/33b: MANAGER2XI METHODS: ", all_methods4xi(manager2xi))
            
            #  ['Array4Xi', 'BoundedSemaphore4Xi', 'Condition4Xi', 'Event4Xi', 'JoinableQueue4Xi', 'Lock4Xi', 'Namespace4Xi', 'Pool4Xi', 'Queue4Xi', 'RLock4Xi', 'Semaphore4Xi', 'Value4Xi',
            #    '_Client', '_Listener', '_Server',
            #    '__class__', '__delattr__', '__enter__', '__eq__', '__exit__', '__format__', '__ge__', '__getattribute__', '__gt__', '__hash__',
            #    '__init__', '__le__', '__lt__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__',
            #    '__weakref__', '_create', '_debug_info', '_finalize_manager', '_number_of_objects',
            #    '_run_server', 'ace', 'connect', 'dict', 'get_server', 'join', 'list', 'reason', 'register', 'sense', 'shutdown', 'start']

        except:
            print("STEP(05Z/33b: *** FAILED TO CREATE MANAGER2XI *** ")

    
            
        # -----------------------------------------------------------------------------------------    
        # Step (06/33 OF TEST_ALL_METHODS4XI) - Manager4Xi.dict
        # -----------------------------------------------------------------------------------------     
        print("STEP(06A/33 OF TEST_ALL_METHODS4XI): TRYING MANAGER2XI.DICT")                        
                        
        try:
            dict2xi = manager2xi.dict()
            print("STEP(06B/33 OF TEST_ALL_METHODS4XI) - DICTIONARY: ", dict2xi)                                 # {} 
        except:
            print("STEP(06Z/33 OF TEST_ALL_METHODS4XI): *** FAILED *** ")

        # -----------------------------------------------------------------------------------------    
        # Step (07/33 OF TEST_ALL_METHODS4XI) - manager2xi.list
        # -----------------------------------------------------------------------------------------     
        print("STEP(07A/33 OF TEST_ALL_METHODS4XI): TRYING MANAGER2XI.LIST")                        
                    
        try:
            list2xi = manager2xi.list(range(15))
            print("STEP(07B/33 OF TEST_ALL_METHODS4XI) - LIST: ", list2xi)                                       # [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14]             
        except:
            print("STEP(07Z/33 OF TEST_ALL_METHODS4XI): *** FAILED *** ")

        # -----------------------------------------------------------------------------------------    
        # Step (08/33 OF TEST_ALL_METHODS4XI) - Process4Xi - note that args list requires manager operations to succeed !
        # -----------------------------------------------------------------------------------------     
        print("STEP(08A/33 OF TEST_ALL_METHODS4XI): TRYING TO CREATE PROCESS2XI")                            
        try:
            process2xi = Process4Xi(target=sense, args=('Energy ',queue2xi, pipe2xi_publisher_channel,lock_xi2,dict2xi,list2xi))
            
            print("STEP(08B/33 OF TEST_ALL_METHODS4XI): process2xi methods: ", all_methods4xi(process2xi))       # ['__class__', '__delattr__', '__eq__', '__format__', '__ge__', '__getattribute__', '__gt__', '__hash__', '__init__', '__le__', '__lt__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__',
                                                                                                                    #  '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '_bootstrap', '_target', 'ace', 'is_alive', 'join', 'reason', 'run', 'sense', 'start', 'terminate']


        except:
            print("STEP(08Z1/33c): *** FAILED TO CREATE PROCESS2XI *** ")
        
        print("STEP(08C/33 OF TEST_ALL_METHODS4XI): TRYING TO START PROCESS4XI")                            
        try:
         
            process2xi.start()
  
            print("STEP(08D/33 OF TEST_ALL_METHODS4XI): STARTED PROCESS2XI")   
        except:
            print("STEP(08Z2/33f): *** FAILED TO START PROCESS4XI *** ")
            
        # -----------------------------------------------------------------------------------------    
        # Step (09/33 OF TEST_ALL_METHODS4XI)
        # -----------------------------------------------------------------------------------------     
        print("STEP(09A/33 OF TEST_ALL_METHODS4XI): TRYING TO RUN PROCESS2XI")                                        
        try:
        
            process2xi.run()
            
            print("STEP(09B/33 OF TEST_ALL_METHODS4XI): RUN PROCESS2XI") 
        except:
            print("STEP(09Z/33 OF TEST_ALL_METHODS4XI): *** FAILED TO RUN PROCESS2XI *** ")

        # -----------------------------------------------------------------------------------------    
        # Step (10/33 OF TEST_ALL_METHODS4XI)
        # -----------------------------------------------------------------------------------------     
        print("STEP(10A/33 OF TEST_ALL_METHODS4XI): TRYING PROCESS2XI METHODS")                
        try:                     
            print ("(10B/33 OF TEST_ALL_METHODS4XI): process2xi alive status: ", process2xi.is_alive())             # True
            print ("(10C/33 OF TEST_ALL_METHODS4XI): process2xi name: ", process2xi.name)                           # Process4Xi-1
            print ("(10D/33c): process2xi PID: ", process2xi.ident)                                                 # 676
            print ("(10E/33 OF TEST_ALL_METHODS4XI): process2xi authentication key: ", process2xi.authkey)          # b'bD\xbe\xb0P/o)\xc4\xa7\xe3\xd4O\xd4\xa7\x9f\xba\xc1Q\x82\x17\xcc\xecj<\xac\x7fs\x07\x06q\x92'
        except:
            print("STEP(10Z/33 OF TEST_ALL_METHODS4XI): *** FAILED WITH PROCESS2XI METHODS *** ")

        # -----------------------------------------------------------------------------------------    
        # Step (11/33 OF TEST_ALL_METHODS4XI)
        # -----------------------------------------------------------------------------------------     
        print("STEP(11A/33 OF TEST_ALL_METHODS4XI): TRYING TO GET FROM QUEUE2XI")                    
        try:            
            print (queue2xi.get())
            
            
            print("STEP(11B/33 OF TEST_ALL_METHODS4XI): GOT FROM QUEUE2XI")                                      # ['DragonXi2_00', 'Energy ', 'sensing!'] 
        except:
            print("\\n STEP(11Z/33c): *** FAILED  TO GET FROM QUEUE2XI *** ")            

        # -----------------------------------------------------------------------------------------    
        # Step (12/33 OF TEST_ALL_METHODS4XI)
        # -----------------------------------------------------------------------------------------     
        print("STEP(12A/33 OF TEST_ALL_METHODS4XI): STARTING RECEIVING 15 MESSAGES FROM PIPE2XI CONSUMER CHANNEL")               
        try:    
            print (pipe2xi_consumer_channel.recv())
            print (pipe2xi_consumer_channel.recv())
            print (pipe2xi_consumer_channel.recv())
            print (pipe2xi_consumer_channel.recv())
            print (pipe2xi_consumer_channel.recv())
            print (pipe2xi_consumer_channel.recv())
            print (pipe2xi_consumer_channel.recv())
            print (pipe2xi_consumer_channel.recv())
            print (pipe2xi_consumer_channel.recv())
            print (pipe2xi_consumer_channel.recv())
            print (pipe2xi_consumer_channel.recv())
            print (pipe2xi_consumer_channel.recv())
            print (pipe2xi_consumer_channel.recv())
            print (pipe2xi_consumer_channel.recv())
            print (pipe2xi_consumer_channel.recv())                                                                 # ['DragonXi2_Sensing_01', 'BIO ', 'Energy ']
                                                                                                                    # ['DragonXi2_Sensing_02', 'CO2 ', 'Energy ']
                                                                                                                    # ['DragonXi2_Sensing_03', 'Coal ', 'Energy ']
                                                                                                                    # ['DragonXi2_Sensing_04', 'Diesel ', 'Energy ']
                                                                                                                    # ['DragonXi2_Sensing_05', 'Electricity ', 'Energy ']
                                                                                                                    # ['DragonXi2_Sensing_06', 'Fusion ', 'Energy ']
                                                                                                                    # ['DragonXi2_Sensing_07', 'Gas ', 'Energy ']
                                                                                                                    # ['DragonXi2_Sensing_08', 'Geo ', 'Energy ']
                                                                                                                    # ['DragonXi2_Sensing_09', 'Hydrogen ', 'Energy ']
                                                                                                                    # ['DragonXi2_Sensing_10', 'Lithium ', 'Energy ']
                                                                                                                    # ['DragonXi2_Sensing_11', 'Nuclear Power ', 'Energy ']
                                                                                                                    # ['DragonXi2_Sensing_12', 'Ocean ', 'Energy ']
                                                                                                                    # ['DragonXi2_Sensing_13', 'Oil ', 'Energy ']
                                                                                                                    # ['DragonXi2_Sensing_14', 'Solar ', 'Energy ']
                                                                                                                    # ['DragonXi2_Sensing_15', 'Wind ', 'Energy ']
            
            print("\\n STEP(12B/33 OF TEST_ALL_METHODS4XI): RECEIVED FROM PIPE2XI CONSUMER CHANNEL 15 MESSAGES")                 
        except:
            print("STEP(12Z/33c): *** FAILED *** ") 

        # -----------------------------------------------------------------------------------------    
        # Step (13/33 OF TEST_ALL_METHODS4XI)
        # -----------------------------------------------------------------------------------------     
        print("STEP(13A/33 OF TEST_ALL_METHODS4XI): DICTIONARY BY MANAGER2XI AND UPDATED BY PROCESS2XI")         
        try:           
            print("STEP(13B/33 OF TEST_ALL_METHODS4XI): DICTIONARY CREATED BY MANAGER2XI AND UPDATED BY PROCESS2XI:")
            print (dict2xi)                                                                                         # {1: 'BIO', 2: 'CO2', 3: 'Coal', 4: 'Diesel', 5: 'Electricity', 6: 'Fusion', 7: 'Gas', 8: 'Geo', 9: 'Hydrogen', 10: 'Lithium', 11: 'Nuclear Power', 12: 'Ocean', 13: 'Oil', 14: 'Solar', 15: 'Wind'}
        except:
            print("\\n STEP(13Z/33 OF TEST_ALL_METHODS4XI): *** FAILED *** ") 

        # -----------------------------------------------------------------------------------------    
        # Step (14/33 OF TEST_ALL_METHODS4XI)
        # -----------------------------------------------------------------------------------------     
        print("\\n STEP(14A/33 OF TEST_ALL_METHODS4XI):  LISTING FOR MANAGER2XI AND PROCESS2XI:")       
        try:               
            print("STEP(14B/33 OF TEST_ALL_METHODS4XI):  LIST FOR MANAGER2XI AND PROCESS2XI:")
            print (list2xi)                                                                                         # [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14]
        except:
            print("STEP(14Z/33c): *** FAILED *** ") 

        # -----------------------------------------------------------------------------------------    
        # Step (15/33 OF TEST_ALL_METHODS4XI)
        # -----------------------------------------------------------------------------------------     
        print ("\n STEP(15A/33 OF TEST_ALL_METHODS4XI) JOINING PROCESS2XI")        
        try:               
            process2xi.join()
            print ("\n STEP(15B/33 OF TEST_ALL_METHODS4XI) PROCESS2XI EXIT CODE AFTER JOIN : ", process2xi.exitcode) # 0 
        except:
            print("STEP(15Z/33c): *** FAILED *** ") 

        # -----------------------------------------------------------------------------------------    
        # Step (16/33 OF TEST_ALL_METHODS4XI)
        # -----------------------------------------------------------------------------------------     
        print ("n STEP(16A/33 OF TEST_ALL_METHODS4XI) terminating process2xi") 
        try:
            process2xi.terminate()
            print ("n STEP(16B/33 OF TEST_ALL_METHODS4XI) TERMINATED PROCESS2XI")                                   
        except:
            print("STEP(16Z/33c): *** FAILED *** ") 
            
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------                 
    finally:        
            
        # ---------------------------------------------------------------------------------------------    
        # Print Trace
        # ---------------------------------------------------------------------------------------------     
        print_trace4xi(t2xi)        
   
         
#</function4xi>
     
# -------------------------------------------------------------------------------------------------
#<function4xi function = "main" usage = "
#   main function to test all methods4xi 
#"> 
#<state4xi status = "NACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def main():

    print('=' *33)
    print("SENSING IT WITH YOURDRAGONXI!")  
    print('=' *33)
        
    test_all_methods4xi()
    
    print('=' *33)
    print("SENSED IT WITH YOURDRAGONXI!")    
    print('=' *33) 
                    
#</function4xi>
             
# -------------------------------------------------------------------------------------------------
#                               
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':
    main()
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_all_methods4xi.txt
#   sense-test-all_methods4xi.xml
#   reason-test-all_methods4xi.xml
#   ace-test-all-methods4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 


#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of test_all_methods4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
